/*
 * Copyright (C) 2009, 2010, 2011, 2012, 2013  by CNRS and Grenoble-INP
 *
 * This file is part of LIBTLMPWT
 *
 * LIBTLMPWT is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Authors: Matthieu Moy <matthieu.moy@imag.fr>, Grenoble-INP
 *          Tayeb Bouhadiba, CNRS
 *          Claude Helmstetter, CNRS
 *
 * This software has been partially supported by the French ANR project HELP
 *                                                         (ANR-09-SEGI-006)
 */

#ifndef _UNTIMED_EXT_HPP_
#define _UNTIMED_EXT_HPP_

#include "tlm.h"

class untimed_extension: public tlm::tlm_extension<untimed_extension> {
public:
  untimed_extension(size_t physical_size):
    m_physical_size(physical_size) {}

  inline size_t get_size() const {return m_physical_size;}

  inline tlm_extension_base* clone() const {
    return new untimed_extension(m_physical_size);
  }
  
  inline void copy_from(tlm_extension_base const &ext) {
    const untimed_extension* ut_ext =
      dynamic_cast<const untimed_extension*>(&ext);
    assert(ut_ext!=NULL && "wrong extension type");
    m_physical_size = ut_ext->m_physical_size;
  }
  
protected:
  size_t m_physical_size;
};

#endif // _UNTIMED_EXT_HPP_
