/*
 * Copyright (C) 2009, 2010, 2011, 2012, 2013  by CNRS and Grenoble-INP
 *
 * This file is part of LIBTLMPWT
 *
 * LIBTLMPWT is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Authors: Matthieu Moy <matthieu.moy@imag.fr>, Grenoble-INP
 *          Tayeb Bouhadiba, CNRS
 *          Claude Helmstetter, CNRS
 *
 * This software has been partially supported by the French ANR project HELP
 *                                                         (ANR-09-SEGI-006)
 */

#ifndef _MEMORY_MAP_H_
#define _MEMORY_MAP_H_

#define INST_RAM_BASEADDR 0x00000000
#define INST_RAM_SIZE     0x00800000

#define SRAM_BASEADDR     0x20100000
#define SRAM_SIZE         0x00400000

#define UART_BASEADDR     0x40600000
#define UART_SIZE         0x00010000

#define TIMER_BASEADDR    0x41C00000
#define TIMER_SIZE        0x00010000

#define INTC_BASEADDR     0x41200000
#define INTC_SIZE         0x00010000

#define VGA_BASEADDR      0x73A00000
#define VGA_SIZE          0x00010000

#define HWGOL_BASEADDR    0x40000000
#define HWGOL_SIZE        0x00010000

#define STORAGE_BASEADDR  0x40010000
#define STORAGE_SIZE      0x00000040

#define TEMP_SENSOR_BASEADDR 0x45000000
#define TEMP_SENSOR_SIZE     0x00010000

#define POWER_CTRL_BASEADDR 0x42000000
#define POWER_CTRL_SIZE     0x00010000

#endif // _MEMORY_MAP_H_
