/*
 * Copyright (C) 2009, 2010, 2011, 2012, 2013  by CNRS and Grenoble-INP
 *
 * This file is part of LIBTLMPWT
 *
 * LIBTLMPWT is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 * Authors: Matthieu Moy <matthieu.moy@imag.fr>, Grenoble-INP
 *          Tayeb Bouhadiba, CNRS
 *          Claude Helmstetter, CNRS
 *
 * This software has been partially supported by the French ANR project HELP
 *                                                         (ANR-09-SEGI-006)
 */

#include <stdlib.h>
#include <inttypes.h>

uint32_t _heap =  0x20200004;

void * malloc ( size_t size ) {
	uint32_t ptr = _heap;
	_heap = _heap + size;
	if( (_heap % 4) ) {
		_heap = _heap + (4 - (_heap % 4));
	}
	return (void*) ptr;
}

void free ( void * ptr ) {

}

void * memset ( void * ptr, int value, size_t num ){
	uint8_t* tab = (uint8_t*) ptr;
	int i;
	for(i=0; i<num; i++)
		tab[i] = 0xFF & value;
	return ptr;
}

void * memcpy ( void * destination, const void * source, size_t num ){
	int i;
	char * dest = (char*) destination;
	char * src = (char*) source;
	for(i=0; i<num; i++)
		dest[i] = src[i];
	return dest;
}

int memcmp ( const void * ptr1, const void * ptr2, size_t num ){
	int i;
	char * dest = (char*) ptr1;
	char * src = (char*) ptr2;
	for(i=0; i<num; i++)
		if (dest[i] != src[i])
			return (dest[i] > src[i]);
	return 0;
}
